
;DednDave OS Info Dump - Version 1.01

;1.01 - added 'ProductId' with product key portion X'ed out

;--------------------------------------------------------------------------

        INCLUDE    \masm32\include\masm32rt.inc
        INCLUDE    \masm32\include\advapi32.inc
        INCLUDELIB \masm32\lib\advapi32.lib

;--------------------------------------------------------------------------

ShReg   PROTO   :DWORD,:DWORD,:DWORD
RdReg   PROTO   :DWORD,:DWORD,:DWORD

;--------------------------------------------------------------------------

        .CONST

VTable   dd Value11,Value12,Value13,Value14,Value15,Value16,Value17
KeyText  db '[HKEY_LOCAL_MACHINE\',0
SubKey1  db 'SOFTWARE\Microsoft\Windows NT\CurrentVersion',0
Value11  db 'ProductName',0
Value12  db 'CurrentVersion',0
Value13  db 'CurrentBuildNumber',0
Value14  db 'SubVersionNumber',0
Value15  db 'CSDVersion',0
Value16  db 'BuildLab',0
Value17  db 'ProductId',0
SubKey2  db 'SOFTWARE\Microsoft\Windows\CurrentVersion\Media Center',0
Value21  db 'Ident',0
QuoText  db 34,0
NoKText  db '(Key not found)',0
NoVText  db '(Value not found)',0

;HKEY_LOCAL_MACHINE\SOFTWARE\Microsoft\Windows NT\CurrentVersion\DigitalProductId
;76477 xp home
        .DATA

Banner   db 13,10
CWTitle  db 'DednDave OS Info Dump'
BanTerm  db 0,10,13,10,0
;end of Banner

        .DATA?

hHeap    dd ?              ;process heap handle
hStdOut  dd ?              ;std output handle
IniAttr  dd ?              ;initial screen attribute
VBufLen  dd ?              ;registry value buffer length
ValType  dd ?              ;registry value type

CursInfo CONSOLE_CURSOR_INFO <>
BufInfo  CONSOLE_SCREEN_BUFFER_INFO <>

;--------------------------------------------------------------------------

        .CODE

_main   PROC

;initialize

        call    SInit

;display the first Key\SubKey name

        print   ADDR KeyText
        print   ADDR SubKey1
        print   chr$(93,13,10)             ;],cr,lf

;display the 7 values for SubKey1

        mov     edx,offset VTable
        mov     ecx,7

OSinf0: push    ecx
        push    edx
        INVOKE  ShReg,
                HKEY_LOCAL_MACHINE,
                ADDR SubKey1,
                [edx]
        pop     edx
        add     edx,4
        pop     ecx
        dec     ecx
        jnz     OSinf0

        print   chr$(13,10)

;display the second Key\SubKey name

        print   ADDR KeyText
        print   ADDR SubKey2
        print   chr$(93,13,10)             ;],cr,lf

;display the value for SubKey2

        INVOKE  ShReg,
                HKEY_LOCAL_MACHINE,
                ADDR SubKey2,
                ADDR Value21
        print   chr$(13,10)

;terminate

        inkey   "Press any key to exit"
        call    SExit
        exit

_main   ENDP

;--------------------------------------------------------------------------

        OPTION  PROLOGUE:NONE
        OPTION  EPILOGUE:NONE

ShReg   PROC    hRKey:DWORD,lpRSubKey:DWORD,lpRValueName:DWORD

;Show registry value

;Call With: key handle (HKEY_CLASSES_ROOT, HKEY_LOCAL_MACHINE, etc)
;           address of subkey string
;           address of value string
;
;  Returns: displays a registry value with name similar to regedit export

        push    ebp
        mov     ebp,esp

;display the value name

        print   chr$(34)                  ;"
        print   [ebp+16]
        print   chr$(34,61)               ;"=

;read and display the registry value

        INVOKE  RdReg,
                [ebp+8],
                [ebp+12],
                [ebp+16]
        cmp     eax,-2
        jae     ShReg2

        push    eax

;"ProductId" is special

        cmp dword ptr [ebp+16],offset Value17
        jz      ShReg4

ShReg0: print   chr$(34)                   ;"
        mov     eax,[esp]
        print   eax
        pop     eax

;release the allocated heap

        INVOKE  HeapFree,
                hHeap,
                NULL,
                eax

;double quote

        mov     eax,offset QuoText

ShReg1: print   eax
        print   chr$(13,10)
        pop     ebp
        ret     12

;handle "not found" errors

ShReg2: jz      ShReg3

        mov     eax,offset NoVText         ;value not found
        jmp     ShReg1

ShReg3: mov     eax,offset NoKText         ;key not found
        jmp     ShReg1

;"ProductId" is special - we do not want to display the guys product key

ShReg4: push    edi
        lea     edi,[eax+9]
        mov     dh,'X'

ShReg5: mov     dl,[edi]
        cmp     dl,'-'
        jz      ShReg7

        or      dl,dl
        jz      ShReg8

        inc     edi
        jmp     ShReg5

ShReg6: mov     dl,[edi]
        cmp     dl,'-'
        jz      ShReg7

        or      dl,dl
        jz      ShReg8

        mov     [edi],dh

ShReg7: inc     edi
        jmp     ShReg6

ShReg8: pop     edi
        jmp     ShReg0

ShReg   ENDP

        OPTION  PROLOGUE:PrologueDef
        OPTION  EPILOGUE:EpilogueDef

;--------------------------------------------------------------------------

        OPTION  PROLOGUE:NONE
        OPTION  EPILOGUE:NONE

RdReg   PROC    hRKey:DWORD,lpRSubKey:DWORD,lpRValueName:DWORD

;Read registry value
;the address returned is allocated heap
;the caller should release the heap block when done using it
;if there is any kind of error, no heap is allocated

;Call With: key handle (HKEY_CLASSES_ROOT, HKEY_LOCAL_MACHINE, etc)
;           address of subkey string
;           address of value string
;           hHeap = heap handle
;
;  Returns: eax = value string address (heap) - n/a if error
;                -1 if Value not found
;                -2 if Key\SubKey not found
;           ecx = value string length (0 if error)
;           ValType = type of value

;establish stack frame

        push    ebp
        mov     ebp,esp

;open the Key\SubKey handle

        push    eax
        INVOKE  RegOpenKeyEx,
                [ebp+8],
                [ebp+12],
                NULL,
                KEY_QUERY_VALUE,
                esp
        xor     ecx,ecx
        or      eax,eax
        mov     eax,-2
        jnz     RdReg1

;use RegQueryValueEx to get the length of the string
;this call will set the VBufLen value for us
;it also tells us early if the value does not exist

        mov dword ptr VBufLen,1
        INVOKE  RegQueryValueEx,
                [ebp-4],
                [ebp+16],
                NULL,
                ADDR ValType,
                NULL,
                ADDR VBufLen
        xor     ecx,ecx
        or      eax,eax
        mov     eax,-1
        jnz     RdReg0

;allocate memory for the string

        mov     eax,0FFFFFFF0h
        and     eax,VBufLen
        add     eax,10h
        INVOKE  HeapAlloc,
                hHeap,
                NULL,
                eax

;use RegQueryValueEx again to get the string

        push    eax
        INVOKE  RegQueryValueEx,
                [ebp-4],
                [ebp+16],
                NULL,
                ADDR ValType,
                eax,
                ADDR VBufLen
        pop     eax
        mov     ecx,VBufLen

;close the key handle

RdReg0: push    ecx
        push    eax
        INVOKE  RegCloseKey,
                [ebp-4]
        pop     eax
        pop     ecx

RdReg1: pop     edx
        pop     ebp
        ret     12

RdReg   ENDP

        OPTION  PROLOGUE:PrologueDef
        OPTION  EPILOGUE:EpilogueDef

;--------------------------------------------------------------------------

SInit   PROC

;set console window title

        INVOKE  SetConsoleTitle,
                ADDR CWTitle
        mov byte ptr BanTerm,13

;save initial cursor visibility value
;set cursor visibility to false (off)

        INVOKE  GetStdHandle,
                STD_OUTPUT_HANDLE
        mov     hStdOut,eax
        INVOKE  GetConsoleCursorInfo,
                eax,
                ADDR CursInfo
        push    CursInfo.bVisible
        mov dword ptr CursInfo.bVisible,FALSE
        INVOKE  SetConsoleCursorInfo,
                hStdOut,
                ADDR CursInfo
        pop     CursInfo.bVisible

;save initial screen attribute

        INVOKE  GetConsoleScreenBufferInfo,
                hStdOut,
                ADDR BufInfo
        movzx   eax,BufInfo.wAttributes
        mov     IniAttr,eax

;set text foregound to high intensity green

        INVOKE  SetConsoleTextAttribute,
                hStdOut,
                FOREGROUND_GREEN or FOREGROUND_INTENSITY

;display the banner

        mov     eax,offset Banner
        print   eax

;get the handle to the process heap

        INVOKE  GetProcessHeap
        mov     hHeap,eax
        ret

SInit   ENDP

;--------------------------------------------------------------------------

SExit   PROC

;restore screen attribute to initial setting

        INVOKE  SetConsoleTextAttribute,
                hStdOut,
                IniAttr

;set cursor visibility to initial setting

        INVOKE  SetConsoleCursorInfo,
                hStdOut,
                ADDR CursInfo
        ret

SExit   ENDP

;--------------------------------------------------------------------------

        END     _main
